#!/bin/perl

#blast2qrna.pl 
#           takes a foo.blast file and puts it in fasta format ready to be used by qrna.c

$nseq1 = 0;
$nseq2 = 0;

$line1 = 0;
$line2 = 0;

$seq = 0;


$max_len = 1000000000;

while (<>) {
    if    (/^>(\S+)/ && $seq == 0) { 
	if ($nseq1 > 0) {
	    if ($numl1[0] < $numr1[$line1-1]) { $start1 = $numl1[0].">".$numr1[$line1-1]; }
	    else                              { $start1 = $numr1[$line1-1]."<".$numl1[0]; }

	    print ">", $name1, "-", $start1, "-", $annotation, "\n";
	    for ($i = 0; $i < $line1; $i++) {
		print "\t", $seq1[$i], "\n"; }
	}
	$line1 = 0;
	$name1 = $1;
	$seq = 1;
	$nseq1++;
    }
    
    elsif (/^>(\S+)/ && $seq == 1) {
	if ($nseq2 > 0) {
	    if ($numl2[0] < $numr2[$line2-1]) { $start2 = $numl2[0].">".$numr2[$line2-1]; }
	    else                              { $start2 = $numr2[$line2-1]."<".$numl2[0]; }

	    print ">", $name2, "-", $start2, "-", $annotation, "\n";
	    for ($i = 0; $i < $line2; $i++) {
		print "\t", $seq2[$i], "\n"; }
	}
	$line2 = 0;
	$name2 = $1;
	$seq = 0;
	$nseq2++;
	$annotation = ""; 
    }
    elsif (/^Query:\s+(\S+)\s+(\S+)\s(\S+)/) { 
	$numl1[$line1] = $1; $seq1[$line1] = $2; $numr1[$line1] = $3; $line1++; }
    elsif (/^Sbjct:\s+(\S+)\s+(\S+)\s(\S+)/) { 
	$numl2[$line2] = $1; $seq2[$line2] = $2; $numr2[$line2] = $3; $line2++; }
    elsif (/^\s+Annotation =\s(.+)/  ) { 
	$more = $1;  @more_parts = split(/ /, $more);
	$info = join("**", @more_parts);
	$annotation = $annotation.$info; }
    else { next; }

}

if (@numl1) {
    if ($numl1[0] < $numr1[$line1-1]) { $start1 = $numl1[0].">".$numr1[$line1-1]; }
    else                              { $start1 = $numr1[$line1-1]."<".$numl1[0]; }
    
    print ">", $name1, "-", $start1, "-", $annotation,  "\n";
    for ($i = 0; $i < $line1; $i++) {
	print "\t", $seq1[$i], "\n"; }
}

if (@numl2) {
    if ($numl2[0] < $numr2[$line2-1]) { $start2 = $numl2[0].">".$numr2[$line2-1]; }
    else                              { $start2 = $numr2[$line2-1]."<".$numl2[0]; }
    
    print ">", $name2, "-", $start2, "-", $annotation, "\n";
    for ($i = 0; $i < $line1; $i++) {
	print "\t", $seq2[$i], "\n"; }
}

