#!/bin/perl


my $file      = shift;
my $case      = shift;
my $logodds   = shift;
my $separate  = shift;
my $identical = shift;

$num = 0;

if   ($case==0) { $tag = "GLOBAL";        }
elsif($case==1) { $tag = "LOCAL_DIAG_VITERBI"; }
elsif($case==2) { $tag = "LOCAL_DIAG_FORWARD"; }
elsif($case==3) { $tag = "LOCAL_SEMI_VITERBI"; }
elsif($case==4) { $tag = "LOCAL_SEMI_FORWARD"; }
elsif($case==5) { $tag = "LOCAL_FULL_VITERBI"; }
elsif($case==6) { $tag = "LOCAL_FULL_FORWARD"; }

$org = 0;

open (FILE,"$file") || die;
while (<FILE>) {

    if (/^>(\S+)/  && $org == 0) 
    { 
	$name_1 = $1;
	$org = 1;
	
    }elsif (/^>(\S+)/  && $org == 1) 
    { 
	$name_2 = $1;
	$org = 0;
	if ($separate) {
	    if ((!$identical && $name_1 !~ $name_2) ||
		( $identical && $name_1 =~ $name_2)) 
	    { 
		print "# $name_1\n"; print "# $name_2\n"; 
	    }
	} else { print "# $name_1\n"; print "# $name_2\n"; }
	
    } elsif (/^$tag/) 
    { 
	$num = 1;
	if ($separate) {
	    if ((!$identical && $name_1 !~ $name_2) ||
		( $identical && $name_1 =~ $name_2)) 
	    { 
		print $case, "\t";
	    }
	}else { print $case, "\t"; }
	
    } elsif (/^\s+ OTH = \s+(\S+)\s+COD =\s+(\S+)\s+RNA =\s+(\S+)\s+$/ 
	     && $num == 1) 
    { 
	$othsc = $1;
	$codsc = $2;
	$rnasc = $3;

	if ($separate) {
	    if ((!$identical && $name_1 !~ $name_2) ||
		( $identical && $name_1 =~ $name_2)) 
	    { 
		print $othsc, "\t"; 
	    } 
	} else { print $othsc, "\t"; }
	
	if ($logodds =~ "SC") { 
	    if ($separate) {
		if ((!$identical && $name_1 !~ $name_2) ||
		    ( $identical && $name_1 =~ $name_2)) 
		{ 
		    print $codsc, "\t", $rnasc, "\n";
		}
	    } else { print $codsc, "\t", $rnasc, "\n";}
	    
	    $num = 0;
	}
	
   } elsif (/^\s+logoddspostOTH =\s+0.000\s+logoddspostCOD =\s+(\S+)\s+logoddspostRNA =\s+(\S+)\s+$/)
   {
       $codlod = $1;
       $rnalod = $2;
       if ($num == 1 && $logodds =~ "LOD") {
	   if ($separate) {
	       if ((!$identical && $name_1 !~ $name_2) ||
		   ( $identical && $name_1 =~ $name_2)) 
	       { 
		   print $codlod, "\t", $rnalod, "\n"; 
	       }
	   } else { print $codlod, "\t", $rnalod, "\n"; }
	   $num = 0;
       }
   }
}


close (FILE);



