#!/bin/perl

# Print a helpful message if the user provides no input file.
if (!@ARGV) { 
        print "usage:     selectblasthist.pl min_id min_len max_eval <file> \n";
        print "min_id:    minimum identity of blast hits allowed \n";
        print "min_len:   minimum length   of blast hits allowed  \n";
        print "max_eval:  maximum evalue   of blast hits allowed  \n";
        exit;
}

my $min_id   = shift;
my $min_len  = shift;
my $max_eval = shift;

$max_len = 1000000000;

while (<>) {
    if    (/^Query=\s+(\S+)/)                          { $query = $1; $query =~ s/[\(\)]/-/g; $query =~ s/[\|]/-/g; }
    elsif (/^\s*Database:\s+(\S+)/)                    { $db = $1;        }
    elsif (/^>\<a name = (\S+)\><\/a\>/)               { $sbjct = $1; $sbjct =~ s/[\(\)]/-/g; $sbjct =~ s/[\|]/-/g; }
    elsif (/^>(\S+)/)                                  { $sbjct = $1; $sbjct =~ s/[\(\)]/-/g; $sbjct =~ s/[\|]/-/g; }
    elsif (/^\s+Score = \d+ \(.+\), Expect = (\S+),/)  { $evalue = $1; $scoreline = $_; }
    elsif (/^\s+Identities = \S+\/(\S+)\s\((\S+)%\)/) 
    {
	$flag = 0;
	$length = $1; 
	$identity = $2; 
	$identityline = $_; 
	if ($length > $min_len && $length <= $max_len && $identity >= $min_id && $evalue <= $max_eval) {
	    $flag = 1;
	    print "\n>", $query, "\n";
	    print ">", $sbjct, "\n";
	    print $scoreline;
	    print $identityline;
	}
    }
    elsif (/^\</) { next; }
    elsif ($flag) { print $_; }

    if (!$query) { $query = "foo"; }
}



